#include "graf.h"
/* #define POKAZ_KROK_PO_KROKU */

unsigned int** AlokujMacierzNaGraf(unsigned int N)
	{ unsigned int **wskaznik;
	unsigned int i;
	wskaznik = (unsigned int**) malloc(N*sizeof(unsigned int*));
	if (!wskaznik) return NULL;
	for (i=0; i<N; i++) { wskaznik[i] = (unsigned int*) malloc(N*sizeof(unsigned int));
			if (!wskaznik[i]) 
				{ wskaznik = NULL;
				break; }
			}
	return wskaznik;
	}
	
void WypelnijMacierzGrafu(unsigned int **MGrafu, unsigned int l_wierzcholkow, unsigned int l_krawedzi)
{ unsigned int i,j, indeks;
for (i=0; i<l_wierzcholkow; i++)
	for (j=0; j<l_wierzcholkow; j++)
		if (i==j) MGrafu[i][j] = 0;
			else MGrafu[i][j] = NIESKONCZONOSC;
/* na poczatku wszystkie elementy macierzy s rwne nieskocznosci, za 
wyjatkiem tych, ktre sa na przekatnej, poniewaz elementy na przekatnej 
mowia o tym jaka jest odleglosc z danego wierzcholka do samego siebie */
for (i=0; i<l_wierzcholkow; i++)
	for (j=0; j<l_krawedzi; j++)
		{ do 	{ indeks = rand() % l_wierzcholkow;
			if (MGrafu[i][indeks]==NIESKONCZONOSC)
				{ MGrafu[i][indeks] = rand() % OGR_DROGI + 1;
				break;
				};
			}
		while (1);
		}
/* Wypelnianie macierzy odbywa sie w taki sposb, ze dla kadego wierzchoka 
losowany jest numer wierzchoka do ktrego mona poprowadzic krawedz, nastepnie 
sprawdzana jest wartosc drogi wpisana we wskazane miejsce w macierzy, jesli 
wartosc ta jest rwna nieskonczonosci, to znaczy, ze mozna w nie wpisac 
losowa wartosc drogi, tworzac nowa krawedz. W przeciwnym wypadku mamy do 
czynienia z dwiema sytuacjami: 1) wylosowany numer wierzchlka jest taki sam
jak wierzcholek z ktrego chcemy poprawowadzic graf, lub 2) do tego wylosowanego
wierzcholka krawedz zostala juz poprowadzona. 
Generowana jest taka liczba krawedzi jaka zostala podana w argumencie funkcji. */
}

void ZwolnijMacierzGrafu(unsigned int **MGrafu, unsigned int l_wierzcholkow)
	{ unsigned int i;
	for (i=0; i<l_wierzcholkow; i++) free(MGrafu[i]);
	free(MGrafu);
	}

	
void PokazMacierzGrafu(unsigned int **MGrafu, unsigned int l_wierzcholkow)
{ unsigned int i,j;
printf("\n  |");
for (i=0; i<l_wierzcholkow; i++) printf("%2d ",i);
for (i=0; i<l_wierzcholkow; i++)
	{ printf("\n%2d|",i); 
	for (j=0; j<l_wierzcholkow; j++) if (MGrafu[i][j]!=NIESKONCZONOSC) 
					printf("%2u ",MGrafu[i][j]);
					else printf(" * ");
	}	
}

void PokazWektorRoboczy(ElementWektoraRoboczego *WRob, unsigned int N)
{ unsigned int i;
printf("\n");
for (i=0; i<N; i++) { if (WRob[i].droga!=NIESKONCZONOSC) 
			printf("%2u",WRob[i].droga);
			else printf(" *");
		printf("U%u ",WRob[i].usuniety);
		}
}	


void AlgorytmDijkstra(ElementWektoraRoboczego *WRob, unsigned int N, unsigned int **MGrafu, unsigned int wierzcholek_poczatkowy)
{ unsigned int i, j, ile_zostawionych=1, nr_nastepnika = wierzcholek_poczatkowy, najmniejszy_wierzcholek;
unsigned char czy_pierwszy_raz;
for (i=0; i<N; i++) { WRob[i].droga = MGrafu[wierzcholek_poczatkowy][i];
	WRob[i].usuniety = (i==wierzcholek_poczatkowy?1:0);
	}
/* kopiowanie pierwszego wiersza macierzy gwnej grafu, albowiem zakadam, e badamy najkrtsze 
drogi z pierwszego wierzchoka */

while (ile_zostawionych)
{ 
#ifdef POKAZ_KROK_PO_KROKU
PokazWektorRoboczy(WRob, N);
#endif
if (nr_nastepnika != wierzcholek_poczatkowy)
	for (i=0; i<N; i++)
		if ((MGrafu[nr_nastepnika][i]!=0)&&(MGrafu[nr_nastepnika][i]!=NIESKONCZONOSC))
			if (WRob[nr_nastepnika].droga + MGrafu[nr_nastepnika][i] < WRob[i].droga)
				WRob[i].droga = WRob[nr_nastepnika].droga + MGrafu[nr_nastepnika][i];
/* Ewentualne dokonanie relaksacji drogi */

czy_pierwszy_raz=1;
for (i=0; i<N; i++)
	{ if (!WRob[i].usuniety) 
		if (czy_pierwszy_raz) { najmniejszy_wierzcholek = i;
			czy_pierwszy_raz=0; }
		 else { if (WRob[i].droga < WRob[najmniejszy_wierzcholek].droga) najmniejszy_wierzcholek = i; }
	};
WRob[najmniejszy_wierzcholek].usuniety = 1;
nr_nastepnika = najmniejszy_wierzcholek; 
/* Wybr wierzchoka o najmniejszej drodze i usunicie go */ 

ile_zostawionych = 0;
for (i=0; i<N; i++) if (!WRob[i].usuniety) ile_zostawionych++;
/* Sprawdzanie ile pozostao jeszcze nieusunitych elementw wektora. */
}	

}