/* Projekt 3. - Algorytm Dijkstry - TPI 
   Autor: Dawid Pichen
   e-mail: dawidpichen@klub.chip.pl

   Jesli program ma wypisywac zawartosci macierzy grafu, oraz wektora 
   roboczego sluzacego do wyznaczenia najkrtszej drogi, to prosze usunac
   komentarz z ponizszej makrodefinicji.
*/

/* #define POKAZUJ_WSZYSTKO */

#include "graf.h"
#include "czas.h"

int main (void)
{ unsigned int **MacierzGrafu, ilosc[] = {10, 50, 75, 100, 250, 500, 750, 1000, 0 }; /* tablica ilosci wierzcholkw */
unsigned char i, indeks=0;
struct timeval start, stop; /* struktura timeval okrelona w plikach naglwkowych jdra */
float zmierzone_czasy[10], wynik, procent_krawedzi;
int l_kr;
FILE *plik;
ElementWektoraRoboczego *WektorRoboczy;

if (!(plik=fopen("wynik.txt","w"))) { 
	printf("\a\nWystpi bd otwarcia pliku do zapisu!");
	return 1;
}
fprintf(plik, "Czasy rednie z %d prb.\nLegenda: N - liczba wierzchokw, K - liczba krawdzi",L_PROB);
srand(time(0));
while (ilosc[indeks])	/* glwna petla programu */
{ printf("\n\n##### Ilosc wierzchokw w grafie %u #####", ilosc[indeks]);
fprintf(plik, "\n\nN = %u:", ilosc[indeks]);
for (procent_krawedzi=0.1; procent_krawedzi<=1; procent_krawedzi+=0.1)
	{ l_kr = (int)(procent_krawedzi*(float)ilosc[indeks]);
	if (l_kr <= 0) continue;
	printf("\n*** Liczba krawdzi w grafie: %d ***", l_kr);
	for (i=0; i<L_PROB; i++)
		{ MacierzGrafu = AlokujMacierzNaGraf(ilosc[indeks]);
		if (!MacierzGrafu) { printf("\a\nBd alokacji pamici!"); return 1; } 
		WypelnijMacierzGrafu(MacierzGrafu, ilosc[indeks], l_kr);
		printf("\n Prba nr %d, czas wykonywania -> ",i);
		gettimeofday(&start, NULL); /* pobierz aktualny czas */
		WektorRoboczy = (ElementWektoraRoboczego*) malloc(ilosc[indeks]*sizeof(ElementWektoraRoboczego));
		if (!WektorRoboczy) { printf("\a\nBd alokacji pamici!"); return 1; }
		AlgorytmDijkstra(WektorRoboczy, ilosc[indeks], MacierzGrafu, 0);
		gettimeofday(&stop, NULL);
		zmierzone_czasy[i]=roznica(start, stop);
		printf("%f sekund.",zmierzone_czasy[i]);
		#ifdef POKAZUJ_WSZYSTKO
		PokazMacierzGrafu(MacierzGrafu, ilosc[indeks]);
		PokazWektorRoboczy(WektorRoboczy, ilosc[indeks]);
		#endif
		ZwolnijMacierzGrafu(MacierzGrafu, ilosc[indeks]);
		free(WektorRoboczy);
		}
	wynik = srednia(zmierzone_czasy);
	printf("\nCzas redni dla N=%u, K=%u: %f sekund.", ilosc[indeks], l_kr, wynik);
	fprintf(plik, "\nK = %d -> %f sekund", l_kr, wynik);
	}
indeks++;
}
fprintf(plik, "\n\n(C) 2005 Dawid Pichen.");
fclose(plik);
return 0;
} 

